instead_version "2.4.1"
require 'sprites'
require 'theme'
require 'click'
require 'sound'
require "timer"
game.enable_autosave = false
click.bg = true
click.press = true
click.button = true
game.fading = function()
end
--установка значений системных переменных в первоначальное значение
function init_sys_vars()
ingame = true --режим игра/тест
format_para =  '    ' --пробелы табуляции ппраграфа
y_btn = theme.get 'win.h' + theme.get 'win.y'+theme.get 'win.fnt.size'
create = false -- режим разработки
test = false --режим теста
obj_gdi = {
{},
{},
{},
{},
{},{},
{},
{},{},{},
}
end


function load_sys_resources()
button = sprite.load('theme/button-blue.png') --кнопка
font_sys = sprite.font('theme/MuSpsk.ttf', theme.get 'menu.fnt.size ')
system = sprite.load('theme/system.png')
system = sprite.scale(system, 0.5, 0.5)
click_snd = sound.load ( 'theme/KeypressStandard.ogg')
click_num = 0
bg_scr_col = sprite.box(theme.get 'scr.w', theme.get 'scr.h', theme.get 'scr.col.bg')
bg = sprite.load(theme.get  'scr.gfx.bg')
--1 - снежинки, 1-4 кадры снежинки
obj_1_1 = sprite.blank(30,30)
obj_1_2 = sprite.blank(30,30)
obj_1_3 = sprite.blank(30,30)
obj_1_4 = sprite.blank(30,30)
sprite_bufer = sprite.blank(30,30)
flake = sprite.load('gfx/flake.png') 


obj_1_4 = sprite.scale(flake, 0.05, 0.05)

sprite_bufer = sprite.scale(flake, 0.02, 0.02)
sprite.copy(sprite_bufer, 0,0,30,30, obj_1_1, 15,15)
sprite.free(sprite_bufer)

sprite_bufer = sprite.scale(flake, 0.03, 0.03)
sprite.copy(sprite_bufer, 0,0,30,30, obj_1_2, 10, 10)
sprite.free(sprite_bufer)

sprite_bufer = sprite.scale(flake, 0.04, 0.04)
sprite.copy(sprite_bufer, 0,0,30,30, obj_1_3, 5, 5)
sprite.free(sprite_bufer)


--sprite.copy(flake, 5,5,30,30, obj_1_4, 0,0)
sp_arrow = sprite.load 'theme/arrow.png'  -- кнопка стрелка
sp_arrow_w = sprite.scale(sp_arrow, 0.1, 0.1)
sp_arrow_s = sprite.rotate(sp_arrow_w, 90)
sp_arrow_e = sprite.rotate(sp_arrow_w, 180)
sp_arrow_n = sprite.rotate(sp_arrow_w, 270)
end

dofile 'modules/creator.lua'

function scena_text(txtit)
y_title_text = theme.get 'scr.gfx.pad'
decor_text( txtit, theme.get 'win.fnt.size', y_title_text, '#A77D00', 1 )
end

------текст, высота шрифта, Yкоордината, цвет текста, толщина тени
function decor_text(txdc, hfnt, yfnt, cfnt, shd)
if hfnt == nil then hfnt = 40 end
if yfnt == nil then yfnt = 0 end
if cfnt == nil then cfnt = theme.get 'win.col.fg' end
if shd == nil then shd = 2 end
font_decor = sprite.font (theme.get 'win.fnt.name' , hfnt)
wsd, hsd = sprite.text_size(font_decor, txdc)
sp_text = sprite.text(font_decor, txdc, cfnt)
sp_text_shadow = sprite.text(font_decor, txdc, '#000000' )

for s=1, shd do
sprite.draw(sp_text_shadow, sprite.screen(), x_const+(w_const/2)-(wsd/2)+s, yfnt+s )
end
sprite.draw(sp_text, sprite.screen(), x_const+(w_const/2)-(wsd/2), yfnt )
reload_screen()
sprite.free_font(font_decor)
sprite.free(sp_text)
sprite.free(sp_text_shadow)
end


function way(wy, nway)
if wy == nil then  wayline = "" wys = ""  return end
razd = "|"
wys = wys..wy..razd
wayline = wayline.."[["..wy.."|"..tostring(nway).."]]"..razd
end

function pln_ways()
wys = string.sub (wys, 1, string.len(wys)-string.len(razd))
wsb, hsb = sprite.text_size(font_win, wys)
locate()
xway = ((w_const/2)-(wsb/2))+x_const
locate(xway)
wayline = string.sub (wayline, 1, string.len(wayline)- string.len(razd) )
pln (wayline, _, _, '#A77D00', 1, 0) -- текст, цтекста, цлинка, цэффекта, нэффекта
end

function inv_box()
 
for i = 1, 4 do
--помещаем слот предмета
sprite.draw(slot1, sprite.screen(), theme.get 'inv.x', theme.get 'inv.y' +40+(i*130))
end
for i = 1, 4 do
--помещаем слот предмета
sprite.draw(slot1, sprite.screen(), theme.get 'inv.x'+120, theme.get 'inv.y' +40+(i*130))
end
reload_screen()
end

function inventory()
inv_box()
if rm_exist == 0 or sys_mode then return end -- это для того, чтобы инвентарь не выводтлся в титульной локации и на системных локациях
locate(theme.get 'inv.x', tonumber(theme.get 'inv.y') )
inv = false
for i =1, #obj_inv do
if obj_inv[i][1] == nil then inv = false break end
	if  obj_inv[i][1] ~= 0 then 
inv = true
text_inv = obj_inv[i][2] 
pln ("У меня есть: ",  '#FF9C00'   )
pln (   '`[['..(text_inv)..'|'..tostring(obj_inv[i][3] )..']]')
		if obj_inv[i][1] >0 then
pln ('` ('..tostring(obj_inv[i][1])..'шт.)')
		end
	end
end
	if  inv == false then
pln ("У меня с собой ничего нет.",    '#FF9C00'     )
	end
end




function finish()
finish_mode = true 
game_evens()
if theme.get 'inv.mode' ~= 'disabled' then  inventory() end
y_sys = tonumber(theme.get 'scr.h')-70
if create == true then
x_sys = tonumber(theme.get 'scr.w')-50
btn_decor (x_sys, y_sys, 50, 50, 999) --область кнопки «разработка»
btn_gdi  (0, 0, 100, 100, 0) -- область меню редактора
decor (creat, x_sys, y_sys)
 end
x_sys = 0+5
if sys_mode ~= true then
decor (system, x_sys, y_sys) --спрайт кнопки «система»
btn_decor (x_sys, y_sys, 50, 50, 998) --область кнопки «система»
end
col_gdi = numgdi -1 --
col_btn = numobj-1
if scan == false then
for i=1, 1000 do
for j=1, 1000 do
end
end
pause = 0 --пауза обнулена
scan = true --кликать разрешено
end
if rm_exist == 0 then
tx = "© author engine: ВладимирТрофимчук, 2016"
wst, hst = sprite.text_size(font_win, tx)
locate (((theme.get 'win.w'/2)-(wst/2))+theme.get 'win.x', theme.get 'scr.h'-hst*2, theme.get 'win.w', 40)
pln (tx, theme.get 'win.col.fg')
end

end


---room ы с записью и  чтением состояния игры ------

function room998()
sys_mode = true --включим режим система для того, чтобы при сканировании областей игнорировалась область системной кнопки
cls()
decor_text ("СОСТОЯНИЕ ИГРЫ", 50, 55, '#FFFFBD')
set()
go_back = rm_back --в переменную go_back занесли номер сцены, из которой было вызвано системное меню
sp_tx = "Save or Load you game?"
wst, hst = sprite.text_size(font, sp_tx)
ytx = 300
locate (((theme.get 'scr.w'/2)-(wst/2)), ytx)
--цвет текста, цвет ссылки, цвет обводки
pln ("[[Save|1000]]  or  [[Load|1001]]  you game?", '#FFFFBD' ,      '#E0D900', '#FFEAC8', 1)
sp_tx = "Курсор-стрелка или без курсора?"
wst, hst = sprite.text_size(font, sp_tx)
locate (((theme.get 'scr.w'/2)-(wst/2)), ytx+50)
pln ("[[Курсор-стрелка|1003]]  или  [[без курсора|1004]]?", '#FFFFBD' ,   '#E0D900', '#FFEAC8', 1)

local x = nil
local y = 930
local w = 200
local h = 50
local hi = 80
----------btn (текст, loc, x, y, w, sound)
--btn ("Сохранить состояние игры", 1000, x, y+hi*1, 1)
--btn("Загрузить состояние игры", 1001, x,  y+hi*2, 1)
btn("Отмена", 1002, x, y, 1)
if not ingame and not test then btn("Включить тест", 1006, x, y-hi*4, 1) elseif not ingame and test then btn("Отключить тест", 1006, x, y-hi*4, 1) 
end
if not ingame and test then btn("Разработка", 1005, x, y-hi*5, 1) end

finish() --вызов последней подпрограммы сцены
end
function room1000() --отгрузка
save_game_var() --сохранение номера сцены на диске в папке save с игрой
rm_exist = go_back --номер сцены взяли из сохранённой ранее переменной, так как нужно сейчас возвращатьмя в то место, отеуда было вызвано системное меню
sys_mode = false --перевели режим в игровой, то есть системный режим отключен
return _G["room"..tostring(rm_exist)]()  --переход на сцену, из которой было вызвано меню
end
function room1001() --загрузка
load_game_var()
--присваиваем нужным переменным значения из таблицы
sys_mode = false --не изменять и не удалять!!! будет зависание
return _G["room"..tostring(rm_exist)]()  --стартуем игру с загруженными значениями
end
function room1002()
rm_exist = go_back
sys_mode = false --не изменять и не удалять!!! будет зависание
return _G["room"..tostring(rm_exist)]() --переход назад к игре с любого места
end
function room1003()
theme.set ('scr.gfx.cursor.normal', 'theme/win/cursor.png')
theme.set ('scr.gfx.cursor.use', 'theme/win/cursor-use.png')
rm_exist = go_back
sys_mode = false --не изменять и не удалять!!! будет зависание
return _G["room"..tostring(rm_exist)]() --переход назад к игре с любого места
end
function room1004()
theme.set ('scr.gfx.cursor.normal', 'theme/cursor.png')
theme.set ('scr.gfx.cursor.use', 'theme/cursor-use.png')
rm_exist = go_back
sys_mode = false --не изменять и не удалять!!! будет зависание
return _G["room"..tostring(rm_exist)]() --переход назад к игре с любого места
end
function room1005()
create = true --включим режим разработки
return creator_game() --процедура разработки игры
end
function room1006()
test = not test
rm_exist = go_back
sys_mode = false --не изменять и не удалять!!! будет зависание
return _G["room"..tostring(rm_exist)]() --переход назад к игре с любого места
end

--create = false --выключим режим разработки
--rm_exist = go_back
--sys_mode = false --не изменять и не удалять!!! будет зависание
--return _G["room"..tostring(rm_exist)]() --переход назад к игре с любого места
--end



function paus()
for i=1, 1000 do
for j=1, 1000 do
end
end
end

function exist()
return _G["room"..tostring(rm_exist)]()
end


function back()
rm_exist = rm_back
return _G["room"..tostring(rm_exist)]()
end

function decor(pic, x, y, scalw, scalh)
  
if scalw == nil then scalw = 1 end
if scalh == nil then scalh = 1 end
if x == nil and y == nil then 
w_gfx, h_gfx = sprite.size(pic)
pic = sprite.scale(pic, tonumber(theme.get 'scr.gfx.w')/w_gfx , (tonumber(theme.get 'scr.gfx.h')/h_gfx)) 
sprite.draw(pic,  0, 0, tonumber(theme.get 'scr.gfx.w'),  tonumber(theme.get 'scr.gfx.h')   , sprite.screen(), tonumber(  theme.get 'scr.gfx.x'),  tonumber(theme.get 'scr.gfx.y')  )
reload_screen()
else
if scalw == 1 and scalh == 1 then
sprite.draw(pic , sprite.screen(), x, y )
reload_screen()
else
pic = sprite.scale(pic, scalw , scalh) 
sprite.draw(pic , sprite.screen(), x, y )
reload_screen()
end
end

end



function decor2()
if scalw == nil and scalh == nil and x == nil and y == nil then

sprite.draw(pic, 0, 0,  tonumber(theme.get 'scr.gfx.w'),  tonumber(theme.get 'scr.gfx.h'), sprite.screen(), tonumber(  theme.get 'scr.gfx.x'),  tonumber(theme.get 'scr.gfx.y')  )


	w, h = sprite.size(pic)
	if w ~= tonumber(theme.get 'scr.gfx.w') and h ~= tonumber(theme.get 'scr.gfx.h') then

	pic2 = sprite.blank( tonumber(theme.get 'scr.gfx.w'),  tonumber(theme.get 'scr.gfx.h'))
	pic = sprite.scale(pic, w/tonumber(theme.get 'scr.gfx.w') , h/   tonumber(theme.get 'scr.gfx.h')) 
	return draw_scr() 
	else
	sprite.draw(pic,  sprite.screen(), tonumber(  theme.get 'scr.gfx.x'),  tonumber(theme.get 'scr.gfx.y')  )
	return
	end
else

if scalw ~= nil and scalh ~= nil then
pic2 = sprite.blank( tonumber(theme.get 'scr.gfx.w'),  tonumber(theme.get 'scr.gfx.h'))
pic = sprite.scale(pic, scalw, scalh)
sprite.copy (pic, 0, 0, tonumber(theme.get 'scr.gfx.w'),  tonumber(theme.get 'scr.gfx.h') , pic2, 0, 0)
sprite.draw(pic2,  0, 0, tonumber(theme.get 'scr.gfx.w'),  tonumber(theme.get 'scr.gfx.h')   , sprite.screen(), x,  y )
sprite.free(pic2)
return 
end

sprite.draw(pic, sprite.screen(), x,  y)

end

end

function draw_scr()
 
sprite.copy (pic, 0, 0, tonumber(theme.get 'scr.gfx.w'),  tonumber(theme.get 'scr.gfx.h') , pic2, 0, 0)
sprite.draw(pic2,  0, 0, tonumber(theme.get 'scr.gfx.w'),  tonumber(theme.get 'scr.gfx.h')   , sprite.screen(), tonumber(  theme.get 'scr.gfx.x'),  tonumber(theme.get 'scr.gfx.y')  )
sprite.free(pic2)
end


--**********************************************
--ВЫВОД КНОПКИ И УСТАНОВКА ЕЁ ПАРАМЕТРОВ ДЛЯ СКАНИРОВАНИЯ
--СИНТАКСИС ОПЕРАТОРА btn:
--btn (атрибуты)
--подробнее: btn ("текст" t, номер перехода l, x, y координаты,  s номер звука, hi межкнопочный интервал по высоте)
function btn(t, l,  x, y, s, hi )
win_col_btn = "#00126B" --цвет текста на кнопке
sp_text = sprite.text(font_btn, t, win_col_btn) --формирование спрайта с текстом
wst, hst = sprite.text_size(font_btn, t) --вычисление размеров текста на кнопке
--0.8
--but = sprite.scale(button, (wst/99), (theme.get 'win.fnt.size'/100)) -- меняем размер кнопки во время игры

w, h = sprite.size(but) -- размеры изменённой кнопки
if x == nil then 
x = (theme.get 'win.x' +(tonumber(theme.get 'win.w')/2)-(w/2)) --вычисление X координаты окна кнопок
end
if hi == nil then hi = 30 end --межкнопочный интервал
if y == nil then --y координата кнопки
btn_win_y = theme.get 'win.y'+theme.get 'win.h' --вычисление Y окна кнопок, зависит от окна текстового
y = btn_win_y +((numbtn-1)*(tonumber(theme.get 'win.fnt.size')+hi)) --вычисление Y координаты кнопки. hi = высота между кнопками
end
 
sprite.draw(sp_text, but, (w/2)-(wst/2), (h/2) -(hst/2)) --помещение спрайта текста в спрайт кнопки
sprite.draw(but, sprite.screen(), x, y) --вывод кнопки с текстом на экран
--занесение значений области кнопки с атрибутами в таблицу областей сканирования
obj_atr[numobj][1] = x
obj_atr[numobj][2] = y
obj_atr[numobj][3] = w
obj_atr[numobj][4] = h
obj_atr[numobj][5] = l --номер локации перехода
obj_atr[numobj][6] = s --звук по нажатию
--очищаем графическую память
sprite.free(but)
sprite.free(sp_text)
--увеличиваем индекс таблицы сканирования
numobj = numobj +1
--увеличиваем порядковый номер кнопок
numbtn = numbtn +1
end


function btn_decor(x, y, w, h, rm, num_snd, pauz)
obj_atr[numobj][1] = x
obj_atr[numobj][2] = y
obj_atr[numobj][3] = w
obj_atr[numobj][4] = h
obj_atr[numobj][5] = rm
obj_atr[numobj][6] = num_snd
obj_atr[numobj][7] = pauz
numobj = numobj +1
end

function btn_gdi (x, y, w, h, rm, num_snd)
obj_gdi[numgdi][1] = x
obj_gdi[numgdi][2] = y
obj_gdi[numgdi][3] = w
obj_gdi[numgdi][4] = h
obj_gdi[numgdi][5] = rm
obj_gdi[numgdi][6] = num_snd
numgdi = numgdi +1
end



function clt(pic) -- очистка текста на спрайтовом фоне
set()
if pic == nil then pic = bg end
-- определяются параметры очищаемого окна
x = theme.get 'win.x'
y = theme.get 'win.y'
w = theme.get 'win.w'
h = theme.get 'win.h'
 
sprite.draw (pic, x, y, w, h, sprite.screen(), x, y) --накладываем фон
end

function cls2()
scan = false
pause = 0
 
frame(bg, theme.get 'scr.w', theme.get 'scr.h',    "#FFFFBD"  ) -- рамку вокруг фона
sprite.draw(bg, sprite.screen(), 0, 0)
set()
end

function set2()
color = theme.get 'win.col.fg'
y_txt = theme.get 'win.y'
x_txt =  theme.get 'win.x'
numobj =1
numbtn = 1
numgdi = 1
end


function cls(scr, fr)
set()
if scr == nil then scr = bg_scr_col end
 
if fr == 1 then 
frame(scr, theme.get 'scr.w', theme.get 'scr.h',    "#FFFFBD"  ) -- рамку вокруг фона
end
sprite.draw(scr, sprite.screen(), 0, 0)
reload_screen()
end 

function set()
finish_mode = false
scan = false
color = theme.get 'win.col.fg'
locate()
numobj =1
numgdi = 1
numbtn = 1
end 

function frame_wind()
 
exam_box = sprite.box (w_const , h_const , "#00B1FF", 0)
frame(exam_box, w_const, h_const, "#FEFF00"  ) -- рамку вокруг фона
sprite.draw(exam_box, sprite.screen(), x_const, y_const)
sprite.free(exam_box)
end

--locate() устанавливает печать в область текстового окна
--x,y,w,h берутся из текстового окна темы
--locate(x,y) устанавливает позицию печати в любое место экрана без ограничений на выход за пределы окна
--x,y из параметров, а w,h игнорируются
--locate(x,y,w,h) устанавливает позицию печати и размер окна выводимого текста
--locate(x) устанавливает x позицию печати, y, w, h остаются прежними
--locate(_, y) устанавливает y позицию печати, x, w,h остаются прежними


function locate (x, y, w, h)

--если используем без параметров
--locate()
	if y == nil and  x == nil and w == nil and h == nil then 
--взяли значения текстового окна из темы
	y_const = tonumber(theme.get 'win.y')
	x_const = tonumber(theme.get 'win.x')
	w  = theme.get 'win.w'
	h = theme.get 'win.h'
--присвоили значения текстового окна
	x_txt = x_const
	y_txt = y_const
	w_const = tonumber(w)
	h_const = tonumber(h)
if test == true then frame_wind() end
	return
	end
--locate(_, y)
	if y ~= nil and x == nil and w == nil and h == nil then y_txt = y return end
--locate(x)
	if x ~= nil and y== nil and w == nil and h == nil  then x_txt = x return end
--locate(x,y), 

if x ~= nil and y ~= nil and w == nil and h == nil  then 
x_txt = x    y_txt = y   return end
	--locate(x,y,w)
if x ~= nil and y ~= nil and w ~= nil and h == nil  then 
x_txt = x    y_txt = y  w_const =w  return end
--locate(x,y,_, h) 
if x ~= nil and y ~= nil and w ~= nil and h == nil  then 
x_txt = x    y_txt = y  w_const =w  return end
--locate(x,y,w,h)
	if x ~= nil and y ~= nil and w ~= nil and h ~= nil  then 
 x_txt = x   x_const = x --начальное x
 y_txt = y   y_const = y --начальное y
 w_const = w -- размер w
 h_const = h -- размер h
if test == true then frame_wind() end
return end
	
end

function p(t)
wt, ht = sprite.text_size(font, t) 
x_txt = x_const+(w_const/2)-(wt/2)
pln(t)
end

---текст, цвет шрифта, цвет ссылки, цвет обводки, n эффекта, шрифт(0 - win, 1 - inv, 2 - menu)
function pln (text, color_fg, color_link, shadow, neffect, f)

if f == nil or f == 0 then font = font_win end
if f == 1 then font = font_inv end
if f == 2 then font = font_menu end

--временно установлю для исправления ошибки вычисления ширины буквы в font
font = font_win




if text == nil then text = "" end
if finish_mode ~= true then
abzac = text
lenth_abzac = #abzac
end
--x_const = theme.get 'win.x'
if color_fg == nil then color = theme.get 'win.col.fg' end
if color_link == nil then color_link = theme.get 'win.col.link'  end
color = color_fg
w_link=0
if  text == "" then 
y_txt2 = y_txt+sprite.font_height(font)+theme.get 'win.fnt.height' 
if y_txt2 > (y_const + h_const) then 
x_txt = x_const --при переходе на следующую строку x печати берётся из переменной x_const , хорошо бы сделать так, что бы она была из установки locate(x,y)
return end
y_txt = y_txt2
x_txt = x_const return
end
local l = x_const + w_const
local m = y_const + h_const
---код вывода всего текста 
w_line =0 --текущую ширину слова обнулим
t = 1
for i=1, #text do --с первого символа до всей длины текста
if string.byte(text, t) == nil then break end --если текущий символа никакой, то выход из цикла
--подсчитывающая процедура
if string.byte(text, t) == 32 or string.byte(text, t) ==  96 then --если код символа 32 пробел или код символа 96 `, то
--первоначальное значение текущей ширины слова
w_line =0 --текущую ширину слова обнулим
if string.byte(text, t) == 32 then
symb = string.sub(text, t, t)
wst, hst = sprite.text_size(font, symb) 

--текущая ширина строки
w_line = w_line + wst
else
x_txt = x_memory --установили нужные координаты печати
y_txt = y_memory
--установим текущую длину слова в 0
w_line = 0 --w_memory
end
r = t+1
for i=0, 20 do
if string.byte(text, r) == nil then break end
	if string.byte(text, r) == 32 then
break
	else
--проверим на ссылку
	if string.byte(text, r) == 91 and string.byte(text, r+1) == 91 then --это ссылки начало
-- нужно пропустить две скобки
r=r+2 --пропустили две скобки
	end
	if string.byte(text, r) == 124 then --это разделитель
-- нужно пропустить его и номер перехода
r=r+1 --пропустили переход
	for i =1, 10 do --цикл для пропуска вывода цифр локации
		if string.byte(text, r) == 93 and string.byte(text, r+1) == 93 then -- обнаружили конец ссылки]]
r= r+2 --пропускаем скобки и выходим из цикла
		break
		end
r = r+1--на следующий символ
	end
	end
if string.byte(text, r) == nil then break end
	if string.byte(text, r) > 191 then 
symb = string.sub(text, r, r)..string.sub(text, r+1, r+1)
r=r+1
	else
	symb = string.sub(text, r, r)
	end
r = r+1
wst, hst = sprite.text_size(font, symb)
--вычислим текущую ширину слова
w_line = w_line + wst
		if x_txt+w_line >= l then
	y_txt = y_txt+sprite.font_height(font)+theme.get 'win.fnt.height'
	x_txt = x_const
--###
if color == color_link then -- значит это цвет ссылки
--бросим ширину  в текущую область и обнулим ширину ссылки
obj_atr[numobj][3] = w_link
w_link =0
--установим следующую область и кинем в нее х,у
numobj = numobj +1
obj_atr[numobj][1] = tonumber(x_txt)
obj_atr[numobj][2] = tonumber(y_txt) --обход бага Instead !!!
--установим маркер-флаг того, что ссылка перешла на следующую строку
link_to_new_line = true
end
	 t=t+1--пропускаем один пробел чтобы его на новой строке не выводить
	break --выход на печать
		end
	end
end
end
--печатающая процедура
if string.byte(text, t) == 9 then symb = format_para
else
--проверка маркера пристыковки текста
	if string.byte(text, t) == 96 then
	t = t+1 -- пропускаем маркер
x_txt = x_memory --установили нужные координаты печати
y_txt = y_memory
--ширина слова текущая
w_line = 0 --w_memory
	end
		if string.byte(text, t) == 91 and string.byte(text, t+1) == 91 then --это ссылки начало
-- нужно пропустить две скобки
t=t+2 --пропустили две скобки
--установим другой цвет шрифта
color = color_link
--установим флаг-маркер перехода в false
link_to_new_line = false
--установим координаты области
obj_atr[numobj][1] = tonumber(x_txt)
obj_atr[numobj][2] = tonumber(y_txt) --обход бага Instead !!!
--обнулим ширину ссылки
w_link =0
		end
if string.byte(text, t) == 124  and  color == color_link    then --это разделитель между словом и номером локации

--вставка ширины ссылки или части ссылки в область скана
obj_atr[numobj][3] = w_link
w_link =0
-- нужно пропустить разделитель 
t=t+1 --пропустили разделитель
--восстановим цвет шрифта
color = color_fg
--очистим номер локации
nloc = ""
for i =1, 10 do --цикл для пропуска цифр перехода на локацию
	if string.byte(text, t) == 93 and string.byte(text, t+1) == 93 then -- обнаружили конец ссылки]]
--вставляем область перехода
obj_atr[numobj][4] = hst-3
obj_atr[numobj][5] = tonumber(nloc)
obj_atr[numobj][6]  = click_num  --номер звука клика по ссылке
--проверим был ли переход на новую строку во время печати ссылки по флагу
if link_to_new_line == true then
--если был, то в предыдущую область кинем номер локации тот же и высоту
obj_atr[numobj-1][4] = hst-3
obj_atr[numobj-1][5] = tonumber(nloc)
obj_atr[numobj-1][6]  = click_num  --номер звука клика по ссылке
--флаг аннулируем
link_to_new_line = nil
end
numobj = numobj + 1 --увеличим области номер для следующей ссылки
t = t+2 --пропускаем скобки и выходим из цикла
	break
	end
nloc = nloc..string.sub(text, t, t)
t = t+1--на следующий символ
end
		end
		if string.byte(text, t) == nil then break end
		if string.byte(text, t) > 193 and string.byte(text, t) < 210 then 
symb = string.sub(text, t, t)..string.sub(text, t+1, t+1)
t = t+1
		else
symb = string.sub(text, t, t)
		end
end
wst, hst = sprite.text_size(font, symb)
--ширина ссылки
w_link = w_link+wst

--проверка выхода за пределы текстового окна по высоте
if y_txt >= m then break end

--эффекты печати текста
if neffect ~= nil then -- будем выводить с эффектом
--печать с обводкой
	if shadow ~= nil and neffect == 2  then obvodka(shadow) end
	if shadow ~= nil and neffect == 1 then teni(shadoe) end
end
--конец печати эффектов
 
sp_text = sprite.text(font, symb, color)
sprite.draw(sp_text, sprite.screen(), x_txt,  y_txt)
sprite.free(sp_text)
x_txt=x_txt+wst
t = t+1
end
--конец цикла печати всего текста

--ширина слова
w_memory = w_line
x_memory = x_txt
y_memory = y_txt
if y_txt >= m  then return end
y_txt = y_txt+sprite.font_height(font)+theme.get 'win.fnt.height' 
x_txt = x_const --после печати всего текста, переход на новую строку
end

function teni(shadow)
 
sp_text = sprite.text(font, symb, shadow)
for s =1, 1 do
sprite.draw(sp_text, sprite.screen(), x_txt+s,  y_txt+s)
end
end




function obvodka(shadow)
 
sp_text = sprite.text(font, symb, shadow)
sprite.draw(sp_text, sprite.screen(), x_txt-1,  y_txt-1)
sprite.draw(sp_text, sprite.screen(), x_txt-2,  y_txt-2)
sprite.draw(sp_text, sprite.screen(), x_txt-1,  y_txt+1)
sprite.draw(sp_text, sprite.screen(), x_txt-2,  y_txt+2)
sprite.draw(sp_text, sprite.screen(), x_txt+1,  y_txt-1)
sprite.draw(sp_text, sprite.screen(), x_txt+2,  y_txt-2)
sprite.draw(sp_text, sprite.screen(), x_txt+1,  y_txt+1)
sprite.draw(sp_text, sprite.screen(), x_txt+2,  y_txt+2)
end









game.click = function(s, press, mb, x, y)

if scan == false then press = false return end --если режим сканирования областей не включен, то выход из кликера

	if clear_text_mode ==  true then --если включился режим очистки текста, то
				clear_text_mode =  false --отключаем режим очистки
				rm_back = rm_exist --для возврата назад
				rm_exist = numer_scena -- номер перехода
 	return  _G["room"..tostring(numer_scena)]() --сам переход
	end
	press_on = press
	if not press then return end
scan_scr(x, y) --сканирование областей
end

---СКАНИРОВАНИЕ ОБЛАСТЕЙ ЭКРАНА
function scan_scr(x, y)
for i = 1, col_btn do --цикл сканируемых областей экрана, col_btn соответствует количеству областей на экране в данное время
--ПРОВЕРКА НА ПОПАДАНИЕ В ОБЛАСТЬ
if x >= obj_atr[i][1]  then  -- 
	if y >= obj_atr[i][2]  then
		if x< obj_atr[i][1] + obj_atr[i][3] then
			if y < obj_atr[i][2] + obj_atr[i][4] then 
--если игрок попал в какую-либо область на экране из сгенерируемых программно на сцене, то
			
if pause_mode == true and obj_atr[i][5] == 998 then break end --если игрок нажал кнопку SYSTEM во время паузы для задержки вывода текста, то принудительно выходим из цикла проверки
if sys_mode and   obj_atr[i][5] == 998    then break end  
--если игра находится в системном экране save/load , то при нажатии на кнопку SYSTEM принудительно выходим из цикла сканирования
				play( obj_atr[i][6] )
			--если в области есть значение звука, то проигрываем звук
				if obj_atr[i][7] ~= nil and obj_atr[i][7]  ~= 0 then --если в области есть значение паузы, то это объект на экране
				pause_next_room(obj_atr[i][7] , obj_atr[i][5]  ) --занесём в переменные счетчика паузы (см. timer) в первоначальные значения
				break --сразу выходим из цикла областей без перехода на другую сцену
				end


				play( obj_atr[i][6] ) 
				rm_new = obj_atr[i][5] --переход на новую комнату берется из 5 атрибута кликнутой области

--[[  переход на опции разработки
				if rm_new ==999 then --если переход-сцена разработка-тест, то
				 test = not test 
				create = false
				return  _G["room"..tostring(rm_exist)]() 
				end --]]
				rm_back = rm_exist --переменная используется для возврата из системного меню назад в любую сцену из которой было вывано системное меню save/load
				rm_exist = rm_new --значение новой сцены заменено
			return _G["room"..tostring(rm_exist)]() --переход на новую сцену
			end
		end
	end
end --проверки областей
end --цикла областей
end -- функции

tbl_obj= {
{},{},{},{},{},
{},{},{},{},{},
}

--обновление запомненного фона под анимацией
function reload_screen()
reload_star()
reload_ice()
end

function reload_ice()
for i =1, 3 do
tbl_obj[i][5] = false
end
end

function reload_star()
for i =1, 10 do
tbl_stars[i][5] = false
end
end
---------
--i = 1, 3 do номер снежинки
--1 сгенерируем атрибуты для снежинки, флаг установки  5 атр. в true
--2 сохраним то место, где будем выводить снежинку в памяти
---j =1
--восстановим место под объектом
--3 поместим j кадр объекта i на дисплей
--4 крутим счетчик паузы, как только обнулился
--5 восстановим место под i снежинкой
--6 смена кадра j+1 , переход на п.3
--7 кончились кадры
--8 крутим счетчик паузы последнего кадра
--9 как только он обнулился, то 
--10 j =5
-- 11   восстановим место под i снежинкой
--12 поместим j кадр на экран
--13 крутим счетчик паузы одного кадра
--14 j=j-1
--15 if j ~= 0 then goto 11 
--16 последнее восстаноаление под снежинкой
--флаг установки в false
--end

function obj_on_display()
for i=1, 3 do
	if tbl_obj[i][5] ~= true then --если флаг установки объекта не включен, то
  set_obj(i) --генерируем объект
	end
if   tbl_obj[i][5] == true and  tbl_obj[i][4]  == 0 then replace_obj(i) end --восстан. места под объектом
if  tbl_obj[i][5] == true and   tbl_obj[i][4]  == 0 then draw_obj(i ) end  --помещаем кадр объекта на дисплей

if tbl_obj[i][5] == true then
pause_obj(i) --пауза кадра объекта
end
end --конец цикла
end

function set_obj(i)
local set = math.floor(rnd(400))
if set >2 then return end
sprite.free (_G["unde_obj"..tostring(i)]) --удаляем спрайт из графической памяти компьютера


local x_obj= math.floor(rnd(tonumber(theme.get'scr.w')))
tbl_obj[i][1] = x_obj
local y_obj = math.floor(rnd(tonumber(theme.get'scr.h')))
tbl_obj[i][2] = y_obj
local p_obj = math.floor(rnd(100))
tbl_obj[i][3] = p_obj --время показа последней снежинки на дисплее
local w_obj =40--ширина восстанавливаемого места
local h_obj =40-- высота восстанавливаемого места
_G["unde_obj"..tostring(i)] = sprite.blank(w_obj, h_obj)
sprite.copy(sprite.screen(), x_obj, y_obj, w_obj, h_obj,  _G["unde_obj"..tostring(i)], 0,0)
tbl_obj[i][4] = math.floor(rnd(5))
tbl_obj[i][5] = true --флаг установки снежинки  false означает, что снежинка стёрта и нужно генерировать другую в другом месте
tbl_obj[i][6] = 1 --счётчик кадров снежинки в 1 --количество выводимых кадров 4 штук: от 1 маленького до 4 самого большого
local k_obj = math.floor(rnd(500))
tbl_obj[i][7] = 5 --k_obj --время показа одного кадра анимации
tbl_obj[i][8] = true --флаг направления анимации
tbl_obj[i][9] = 4 --число кадров анимации
end

function draw_obj(i) --номер объекта


local f = 1 --1 это снежинки
local x_obj = tbl_obj[i][1]
local y_obj = tbl_obj[i][2]
local j = tbl_obj[i][6] --номер кадра

if j == 0 then tbl_obj[i][5] = false
replace_obj(i) return
end

--спрайтовый вывод obj_i_j на дисплей
sprite.draw(_G["obj_"..tostring(f).."_"..tostring(j)], sprite.screen(), x_obj, y_obj)


if tbl_obj[i][8] == true then j = j +1
elseif tbl_obj[i][8]  == false then  j = j -1 
end

if tbl_obj[i][8] == nil then  j = j +0
end
tbl_obj[i][6] = j
if j == tbl_obj[i][9]  then tbl_obj[i][8] = false return end

end


function pause_obj(i) --пауза после вывода одного кадра объекта
if tbl_obj[i][4]  == tbl_obj[i][7] then
tbl_obj[i][4]  = 0
return
else
tbl_obj[i][4]   = tbl_obj[i][4]   +1
end
end



function replace_obj(i)
local x_obj = tbl_obj[i][1] 
local y_obj = tbl_obj[i][2] 
sprite.draw (_G["unde_obj"..tostring(i)], sprite.screen(), x_obj, y_obj) --накладываем кусочек фона на объект
end

---рисование  звездочек на экране
function stars_on_display()
for i=1,10 do
	if tbl_stars[i][5] ~= true then --если false или nil
set_stars(i)
draw_stars(i) 
	else --если звезда установлена, то пк считает задержку для просмотра звезды перед её стиранием
	pause_stars(i)
	end
end --конец цикла
end

tbl_stars = {
{},{},{},{},{},
{},{},{},{},{},
}

function set_stars(i)

local x_star = math.floor(rnd(tonumber(theme.get'scr.w')))
tbl_stars[i][1] = x_star
local y_star = math.floor(rnd(tonumber(theme.get'scr.h')))
tbl_stars[i][2] = y_star
local p_star = math.floor(rnd(100))
tbl_stars[i][3] = p_star
local w_stars =3 --ширина восстанавливаемого места
local h_stars =3 -- высота восстанавливаемого места
_G["spr_stars"..tostring(i)] = sprite.blank(w_stars, h_stars)
sprite.copy(sprite.screen(), x_star, y_star, w_stars, h_stars,  _G["spr_stars"..tostring(i)], 0,0)
end

function draw_stars(i)
local c_star = "#ffffff"
local x_star = tbl_stars[i][1] 
local y_star = tbl_stars[i][2] 
--пиксельное рисование звездочек 2 на 2
sprite.pixel (sprite.screen(), x_star, y_star, c_star)
sprite.pixel (sprite.screen(), x_star+1, y_star, c_star)
sprite.pixel (sprite.screen(), x_star, y_star+1, c_star)
sprite.pixel (sprite.screen(), x_star+1, y_star+1, c_star)
tbl_stars[i][4] = 0 --счётчик звезды в 0
tbl_stars[i][5] = true
end

function pause_stars(i)
if tbl_stars[i][4]  == tbl_stars[i][3]  then
tbl_stars[i][4]  = 0
return   clear_stars(i) 
else
tbl_stars[i][4]   = tbl_stars[i][4]   +1
end
end

function clear_stars(i)
local x_star = tbl_stars[i][1] 
local y_star = tbl_stars[i][2] 
sprite.draw (_G["spr_stars"..tostring(i)], sprite.screen(), x_star, y_star) --накладываем кусочек фона на звезду
tbl_stars[i][5] = false
sprite.free (_G["spr_stars"..tostring(i)]) --удаляем спрайт из графической памяти компьютера
end
----конец процедур рисования одной звездочки


--процедура задержки вывода сообщения перед его удалением
function pause_counter()
if pause_count == nil and pause_end == nil then return end
	if pause_count == pause_end or press_on then 
--выход из режима паузы
pause_count =0 --счётчик паузы обнуляется
pause_end =1
clear_text_mode = true --режим очистки от текста включается
	pause_mode = false --режим паузы отключается
	return end --выход из процедуры
clear_text_mode =false --режим очистки отключается
pause_count = pause_count +1 --счетчик прибавляется на 1
end

--процедуры присваивания значений переменных для паузы и перехода
function auto_pause_next_room(n)
s = math.floor((lenth_abzac+1)/10)
paused(s)
next_room(n)
end
function pause_next_room(s, n) --присвоение значений переменным
paused(s)
next_room(n)
end
function next_room(n) --присвоение значений переменным
numer_scena = n
end
function paused(s)
if s == nil then s=1 end
pause_count = 0
pause_mode = true
s = s*20
pause_end = s
end
------конец процедур присвоения переменных для паузы и перехода
function pause_process()
	if pause_mode == true then return pause_counter() --если включен режим паузы, то считаем паузу
else --режим паузы отключен, то
if clear_text_mode ==  true then --если включился режим очистки текста, то
				clear_text_mode =  false --отключаем режим очистки
				rm_back = rm_exist --для возврата назад
				rm_exist = numer_scena -- номер перехода
 	return  _G["room"..tostring(numer_scena)]() --сам переход на другую сцену по окончанию паузы
	end
	end
end


game.timer = function(s)
stars_on_display()
obj_on_display()
pause_process()
test_prog() --процедуры для тестирования игры с выводом  номеров сцен
end


function test_prog()
		if not test then return 
		end
--print_vars(pause_count, 0, 0, 'cnt', 150)
--print_vars(clear_text_mode, 60, 0, 'cltm', 150)
--print_vars(w_gfx, 100, 0, 'w', 150)
--print_vars(h_gfx, 150, 0, 'h', 150)
--print_vars(w_const, 280, 0, 'w окна =', 150)
--print_vars(h_const, 400, 0, 'h окна =', 150)
		--начало процедур тестового режима и режима разработки
		frame_win() --вывод области текста
		if test then print_vars(rm_exist, 200, 0, 'room', 150) --номер текущей сцены
		end 
		--вывод рамок  системных областей
			if col_gdi ~= 0 then
				if create == true then --режим разработки
					for i = 1, col_gdi do
					draw_box2(i) --обводка системных областей
					end
				end
			end
--вывод рамок системных областей закончен
--вывод рамок игровых областей в режиме тестирования
					if col_btn == 0 or col_btn == nil then return
					end
					if create then return 
					end --если в режиме разработки, то выход из прерывания
					for i = 1, col_btn do
						if test == true then --в режиме тестирования
							if     obj_atr[i][5] ~=999 then 
							draw_box(i) --рисование областей игры
							end
						end
					end
end

--создание таблицы состояния игры

--кодируем типы переменных
local types = {
    bool = 0x0,
    number = 0x1,
    string = 0x2,
    table = 0x3,
    endtable = 0x4
}
local types_char = {
    bool = string.char(0x0),
    number = string.char(0x1),
    string = string.char(0x2),
    table = string.char(0x3),
    endtable = string.char(0x4)
}
 
--Запаковываем массив и записываем в файл
--Внимание! Строки в структуре не должны содержать символов с кодами 0-31
local pack_array = function(t, f)
    if t == nil or type(t) ~= "table" or next(t) == nil then
        return false --выход из процедуры с ложным знаком, если входящее значение t не является таблицей либо не существует t, либо не существует следующего значения next (t) ?
    end
    if f == nil then
        return false --если входящее значение f  не существует, то выход с ложным знаком
    end
    for k,v in pairs(t) do --проход по всей таблице
        if v ~= nil then
            if type(k) == "number" then
                f:write(types_char.number)
                f:write(tostring(k))
            elseif type(k) == "string" then
                f:write(types_char.string)
                f:write(k)
            else
                error("unsupported key type (0) "..type(k))
            end
            if type(v) == "number" then
                f:write(types_char.number)
                f:write(tostring(v))
            elseif type(v) == "string" then
                f:write(types_char.string)
                f:write(v)
            elseif type(v) == "boolean" then
                f:write(types_char.bool)
                if v == true then
                    f:write("1")
                elseif v == false then
                    f:write("0")
                end
            elseif type(v) == "table" then
                f:write(types_char.table)
                pack_array(v, f)
                f:write(types_char.endtable)
            end
        end
    end
return true
end
 
--Распаковываем прочитанный из файла массив
local unpack_array = function(str, idx)
    local get_byte = function(_str, idx_)
        return string.byte(string.sub(_str, idx_, idx_)), idx_ + 1
    end
    local get_string = function(_str, idx_)
        local idx1 = string.len(_str) + 1
        for i=idx_,string.len(_str),1 do
            if string.byte(string.sub(_str,i,i)) < 32 then
                idx1 = i
                break
            end
        end
        return string.sub(_str,idx_,idx1-1),idx1
    end
    local get_num = function(_str,idx_)
        local st, idx1 = get_string(_str, idx_)
        return st+0, idx1
    end
    local get_bool = function(_str,idx_)
        local st, idx1 = get_string(_str, idx_)
        return st == "1", idx1
    end
    if str == nil or str == "" then
        return {}
    end
local ret = {}
local vtype = 0
idx = idx or 1
    while (true) do
        local key, value = 0, 0
        if idx > string.len(str) then
            return ret, idx
        end
        vtype, idx = get_byte(str, idx)
        if vtype == types.number then
            key, idx = get_num(str,idx)
        elseif vtype == types.string then
            key, idx = get_string(str, idx)
        elseif vtype == types.endtable then
            return ret, idx
        else
            error("unsupported key type (1) "..tostring(vtype))
        end
        vtype, idx = get_byte(str, idx)
        if vtype == types.number then
            value, idx = get_num(str, idx)
        elseif vtype == types.string then
            value, idx = get_string(str, idx)
        elseif vtype == types.bool then
            value, idx = get_bool(str, idx)
        elseif vtype == types.table then
            value, idx = unpack_array(str, idx)
        else
            error("unsupported key type (2) "..tostring(vtype))
        end
        ret[key] = value
    end
end


---процедуры записи и чтения состояния игры

--Записываем
function write(path, tbl) --путь к файлу, таблица состояния игры
local f = io.open(path, "w") --открытие доступа для записи на диск
    if f ~= nil then -- если существует доступ, то
        pack_array(tbl, f) --пакуем таблицу и записываем там
        f:close() --закрываем доступ
    end
end
 
--Читаем
function read(path) --путь к файлу
local f = io.open(path, "r") --открываем доступ к чтению
    if f ~= nil then --если доступ существует, то
        local data = unpack_array(f:read("*a")) --Новый метод чтения, читаем распаковывая файл
        f:close() --закрываем доступ
        return data --на выходе все данные в data
    else
        return {} --при ложном знаке на выходе пустая таблца
    end
end
 

--Пример использования процедуры
function save_game_var()
--формируем отгрузочное состояние в таблицу
tbl = {}
tbl[1] = go_back --записали в таблицу текущую сцену
--записываем ее в файл
write("save/save.txt", tbl) --(путь к файлу, tbl)
end

function load_game_var()
--читаем файл в таблицу
local tbl = read("save/save.txt") --(путь к файлу)
rm_exist = tbl[1]
end


--help proc вспомогательные процедуры
 function print_vars(v1, x,y, txv, ltx)
if ltx == nil then ltx = 30 end
if txv == nil then txv = "var" end
	if v1 == nil then 
	var_txt= sprite.text(font_sys, txv.."= nil", 'white')
	else
		if type(v1) == 'boolean' then
		
			if v1 == false then
			var_txt= sprite.text(font_sys, txv.." = false", 'white')
			else 
			var_txt= sprite.text(font_sys, txv.." = true", 'white')
			end
		else 
		var_txt= sprite.text(font_sys, txv.."="..(v1), 'white')
		end
	end
local black_box = sprite.box (ltx, 30, "#000000", 255)
sprite.draw (black_box, sprite.screen(), x, y)
sprite.draw(var_txt, sprite.screen(), x+3, y+3)
sprite.free(var_txt)
sprite.free(black_box)
end

function frame_win(x, y, w, h)
if x == nil and y== nil and w == nil and h == nil then
x = theme.get 'win.x'
y = theme.get 'win.y'
w = theme.get 'win.w'
h = theme.get 'win.h'
end
local exam_box = sprite.box (w , h , "#00B1FF", 0)
frame(exam_box, w, h,    "#FEFF00"  ) -- рамку вокруг фона
sprite.draw (exam_box, sprite.screen(), x, y)
sprite.free(exam_box)
end


function draw_box2(i)
print_vars(obj_gdi[i][5], obj_gdi[i][1], obj_gdi[i][2])
frame_win(   obj_gdi[i][1]  ,      obj_gdi[i][2] ,      obj_gdi[i][3],      obj_gdi[i][4]   )
end


function draw_box(i)
print_vars(obj_atr[i][5], obj_atr[i][1], obj_atr[i][2])
exam_box = sprite.box (obj_atr[i][3] , obj_atr[i][4] , "#00B1FF", 0)

if create == true then
exam_box = sprite.box (obj_atr[i][3] , obj_atr[i][4] , "#00B1FF", 180)
else
frame(exam_box, obj_atr[i][3], obj_atr[i][4],    "#FEFF00"  ) -- рамку вокруг фона
end
-- поместим на экран фон
sprite.draw (exam_box, sprite.screen(), obj_atr[i][1] , obj_atr[i][2] )
sprite.free(exam_box)
end






function frame(sp_box2, box2w, box2h, col_bord)
for x=0, box2w do -- линия сверху
y=0
sprite.pixel (sp_box2, x, y, col_bord)
end
for x=0, box2w do -- линия снизу
y= box2h-1
sprite.pixel (sp_box2, x, y, col_bord)
end

for y=0, box2h do -- линия справа
x= box2w-1
sprite.pixel (sp_box2, x, y, col_bord)
end
for y=0, box2h do -- линия слева
x= 0
sprite.pixel (sp_box2, x, y, col_bord)
end
end
